/**
Copyright: 2024 Contrast Security, Inc
  Contact: support@contrastsecurity.com
  License: Commercial

  NOTICE: This Software and the patented inventions embodied within may only be
  used as part of Contrast Security’s commercial offerings. Even though it is
  made available through public repositories, use of this Software is subject to
  the applicable End User Licensing Agreement found at
  https://www.contrastsecurity.com/enduser-terms-0317a or as otherwise agreed
  between Contrast Security and the End User. The Software may not be reverse
  engineered, modified, repackaged, sold, redistributed or otherwise used in a
  way not consistent with the End User License Agreement.
*/
'use strict';

/**
 * @module lib/rules/protect/in-filters/Function
 * InFilter hooks for Function constructor.
 */
const _ = require('lodash');

const constants = require('../../constants');
const patcher = require('../../hooks/patcher');
const { PATCH_TYPES } = require('../../constants');
const BaseSensor = require('../../hooks/frameworks/base');

const { SINK_TYPES } = constants;
const ID = 'global.Function';
const { emitSinkEvent } = require('../../hooks/frameworks/common');

const ContrastFunction = require('../../core/rewrite/injections').get(
  'Function'
);

/**
 * Resolves the arguments passed to the function constructor to
 * the actual body of the function, ignoring the arguments.
 * @param {string[]} args Function arguments object
 * @returns {string} The function body argument
 */
const resolveFnBody = (args) => _.last(args);

class FunctionSensor extends BaseSensor {
  constructor(agent) {
    super({ id: ID, agent });
  }

  install() {
    ContrastFunction.enable();
    patcher.patch(ContrastFunction.value, {
      alwaysRun: true,
      name: 'Function',
      patchType: PATCH_TYPES.PROTECT_SINK,
      pre(data) {
        emitSinkEvent(resolveFnBody(data.args), SINK_TYPES.CODE_STRING, ID);
      }
    });

    return this;
  }
}

module.exports = FunctionSensor;
